
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:flutter/material.dart';

class ApmModule {
  static const MethodChannel _channel = const MethodChannel('apm_module');

  //TODO Vincent method to remove after
  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future initAppWithAppID(String partnerID, String partnerSecret, String appId) async {
    debugPrint('Vincent, initAppWithAppID(String $partnerID, String $partnerSecret, String $appId) 1');

    try {
      await _channel
          .invokeMethod('initAppWithAppID', <String, dynamic>{
            'partnerId': partnerID,
            'partnerSecret': partnerSecret,
            'appId': appId,
          })
          .then((result) {
            debugPrint('Vincent, initAppWithPartnerID() 2');
      });
    } on PlatformException catch (e) {
      print(e.message);
    }
  }

  static Future refreshSDK(bool force) async {
    debugPrint('Vincent, refreshSDK(bool $force) 1');

    try {
      await _channel
          .invokeMethod('refreshSDK', force)
          .then((result) {
            debugPrint('Vincent, refreshSDK() 2');
      });
    } on PlatformException catch (e) {
      print(e.message);
    }
  }

  static Future setBaseUrl(String baseUrl) async {
    try {
      await _channel
          .invokeMethod('setBaseUrl', baseUrl)
          .then((result) {
            debugPrint('Vincent, setBaseUrl() 2');
      });
    } on PlatformException catch (e) {
      print(e.message);
    }
  }
}
